package kc.mega.gun;

import kc.mega.learning.KNNHitRangeModel;
import kc.mega.learning.Model;

public class AimModels {
  public static Model getMainGun() {
    return new KNNHitRangeModel.Builder("Main")
        .features(new String[] {"virtuality", "bft", "accel", "vel", "advDir", "vChangeTimer",
              "dirChangeTimer", "decelTimer", "orbitalWallAhead", "orbitalWallReverse",
              "maeWallAhead", "maeWallReverse", "stickWallAhead", "stickWallReverse"})
        .params(new double[][] {
          {1.1834, 0.0652, 0.2924},
          {2.5356, 0.6693, 0.0052},
          {8.1991, 0.0253, 0.2014},
          {1.8729, 0.0583, 0.2141},
          {0.6756, 0.5708, 2.2945},
          {1.1065, 0.2909, 0.5409},
          {0.6933, 0.3386, 0.5182},
          {1.7230, 0.0038, 0.2524},
          {3.8194, 0.1026, 0.3117},
          {1.5303, 0.0134, 0.3792},
          {1.0881, 0.7027, 2.5930},
          {0.9736, 0.1861, 2.9362},
          {1.3018, 1.9157, 1.3197},
          {2.0707, 0.0191, 0.2525}})
        .distanceScale(-0.5931)
        .neighborhoodSizeDivider(5.0)
        .maxNeighbors(200)
        .maxNeighborsFast(50)
        .maxTreeSize(50000).build();
  }

  public static Model getAntiSurferGun() {
    return new KNNHitRangeModel.Builder("AntiSurfer")
        .features(new String[] {"virtuality", "bft", "accel", "vel", "advDir", "vChangeTimer",
            "dirChangeTimer", "maeWallAhead", "maeWallReverse", "stickWallAhead", "stickWallReverse",
            "shotsFired", "didHit", "didCollide"})
        .params(new double[][] {
          {1.3678, 0.0038, 0.5037},
          {3.5415, 0.4470, 0.6993},
          {6.8680, 0.0230, 0.1731},
          {1.2590, 0.3130, 0.2206},
          {0.4960, 0.3868, 1.5427},
          {0.0354, 0.0729, 1.2583},
          {0.1306, 0.8244, 0.1174},
          {2.7647, 0.6126, 1.9281},
          {0.9255, 0.1481, 1.2874},
          {1.5061, 0.5026, 0.9971},
          {2.4071, 0.0263, 0.6730},
          {0.0110, 0.9010, 0.0112},
          {0.4809, 0.4634, 1.4637},
          {0.5, 0, 1}})
        .distanceScale(-0.9146)
        .neighborhoodSizeDivider(5.0)
        .maxNeighbors(100)
        .maxNeighborsFast(30)
        .maxTreeSize(50000).build();
  }
}
