package kc.mega.movement;

import kc.mega.game.BotState;
import kc.mega.other.Painter;
import kc.mega.wave.WaveWithFeatures;

import java.awt.Color;

public class MovementWave extends WaveWithFeatures {
  public final boolean isVirtual;

  public static class Builder extends WaveWithFeatures.Builder {
    public boolean isVirtual;
    public Builder isVirtual(boolean val) {isVirtual = val; return this;}
    @Override
    public MovementWave build() {return new MovementWave(this);}
  }

  private MovementWave(Builder builder) {
    super(builder);
    this.isVirtual = builder.isVirtual;
  }

  @Override
  public void paint(BotState enemyState, Foam foam) {
    if (isVirtual && fireTime >= enemyState.gameTime) {
      Painter.THIS_TICK.addPoint(
          fireTime == enemyState.gameTime ? Color.yellow : Color.white, source, 3);
    } else {
      super.paint(enemyState, foam);
    }
  }
}
