package kc.mega.other;

import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public enum Stopwatch {
  INSTANCE;

  private static Map<String, Long> startTimes = new HashMap<>();;
  private static Map<String, Long> totalMillis = new HashMap<>();;
  private static String currentTimers = "";

  public void start(String key) {
    currentTimers += "/" + key;
    startTimes.put(currentTimers, System.currentTimeMillis());
  }

  public void stop() {
    if (!currentTimers.isEmpty()) {
      totalMillis.put(currentTimers, totalMillis.getOrDefault(currentTimers, 0L) +
          System.currentTimeMillis() - startTimes.get(currentTimers));
      currentTimers = currentTimers.substring(0, currentTimers.lastIndexOf('/'));
    }
  }

  public void stopAll() {
    while (!currentTimers.isEmpty()) {
      stop();
    }
  }

  public void print() {
    Map<String, Long> additionalMillis = new HashMap<>();
    List<String> timers = new ArrayList<>(startTimes.keySet());
    Collections.sort(timers);
    for (String timer : timers) {
      long currentTimerMillis = totalMillis.get(timer);
      additionalMillis.put(timer, currentTimerMillis);
      timer = timer.substring(0, timer.lastIndexOf('/'));
      if (!timer.isEmpty()) {
        additionalMillis.put(timer, additionalMillis.get(timer) - currentTimerMillis);
      }
    }

    double total = additionalMillis.values().stream().mapToLong(Long::valueOf).sum();
    System.out.println("Total compute usage: " + total);
    for (String timer : timers) {
      String s = "";
      for (int i = 0; i < timer.chars().filter(ch -> ch == '/').count(); i++) {
        s += " ";
      }
      s += timer.substring(timer.lastIndexOf('/') + 1) + ":";
      System.out.println(s + String.format(
          " %.2f", 100.0 * additionalMillis.get(timer) / total) + "%");
    }
  }
}
